package com.qmth.distributed.print.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.qmth.distributed.print.business.entity.TPCourse;
import com.qmth.distributed.print.business.entity.TPRequirement;
import com.qmth.distributed.print.business.mapper.TPRequirementMapper;
import com.qmth.distributed.print.business.service.TPRequirementService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.teachcloud.common.entity.SysUser;
import com.qmth.teachcloud.common.util.ServletUtil;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 专业认证毕业要求 服务实现类
 * </p>
 *
 * @author xf
 * @since 2024-04-22
 */
@Service
public class TPRequirementServiceImpl extends ServiceImpl<TPRequirementMapper, TPRequirement> implements TPRequirementService {

    @Override
    public List<TPRequirement> listRequirement(Long professionalId) {
        QueryWrapper<TPRequirement> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(TPRequirement::getProfessionalId, professionalId)
                .orderByAsc(TPRequirement::getSortNum);
        return this.list();
    }

    @Override
    public boolean saveRequirement(TPRequirement tpRequirement) {
        SysUser sysUser = (SysUser) ServletUtil.getRequestUser();
        // 修改
        if(tpRequirement.getId() != null){
            tpRequirement.updateInfo(sysUser.getId());
        }
        // 新增
        else {
            tpRequirement.insertInfo(sysUser.getId());
        }
        // todo 节点数变动后，修改矩阵数据
        this.saveOrUpdate(tpRequirement);
        return true;
    }

    @Override
    public boolean saveSort(List<TPRequirement> requirementList) {
        requirementList.forEach(t -> {
            if (t.getId() != null && t.getSortNum() != null) {
                UpdateWrapper<TPRequirement> updateWrapper = new UpdateWrapper();
                updateWrapper.lambda().set(TPRequirement::getSortNum, t.getSortNum())
                        .eq(TPRequirement::getId, t.getId());
                this.update(updateWrapper);
            }
        });
        return true;
    }
}
